/* eslint-disable max-classes-per-file */
/* eslint-disable no-console */ // we're okay with outputting diagnostic info to the console.

/* we aren't using the buiLogger yet, but i wanted to abstract away from using console.X directly
for when the handling becomes more sophisticated later */
/* eslint-disable-next-line no-unused-vars */ // used by other files in the program
class Log {
  constructor(buiLogger) {
    this.buiLogger = buiLogger;
    this.lio = "[LIO]";
  }

  info(...args) {
    console.info(this.lio, ...args);
    // this.buiLogger.info(message);
  }

  warn(...args) {
    console.warn(this.lio, ...args);
    // this.buiLogger.warn(message);
  }

  error(...args) {
    console.error(this.lio, ...args);
    // this.buiLogger.error(message);
  }

  static alert(message) {
    /* eslint-disable-next-line no-alert */ // OK to alert for critical errors
    window.alert(message);
  }
}

// creating a custom error type because we only want to show our own errors in agent alerts.
/* eslint-disable-next-line no-unused-vars */ // used by other files in the program
class LanguageIOError extends Error {
  constructor(message) {
    super(message);
    this.name = "LanguageIOError";
  }
}
