/* global agentTextEditor, oscRestManager */

const standardTextPopup = {
  popup: null,
  hotkeyEntry: null,
  failureText: null,
  setup() {
    this.popup = document.getElementById("standard_text_popup");
    this.hotkeyEntry = document.getElementById("standard_text_popup_hotkey_entry");
    this.failureText = document.getElementById("standard_text_popup_failure");
    agentTextEditor.addEventListener("keyup", standardTextPopup.display);

    // setup submission event
    this.hotkeyEntry.addEventListener("keyup", (innerKeyup) => {
      if (innerKeyup.key === "Enter") {
        oscRestManager
          .getStandardText(this.hotkeyEntry.value)
          .then((returnedText) => {
            this.hotkeyEntry.value = "";
            if (returnedText) {
              agentTextEditor.editor.value += returnedText;
              standardTextPopup.close();
            }
          })
          .catch(() => {
            this.hotkeyEntry.hidden = true;
            this.failureText.hidden = false;
            document.getElementById("standard_text_popup_ok_button").focus();
          });
      }
    });
  },
  display(keyup) {
    if (keyup.key === "F8") {
      standardTextPopup.popup.hidden = false;
      standardTextPopup._resetHotkeyEntry();
      standardTextPopup.hotkeyEntry.focus();
    }
  },
  close() {
    this._resetHotkeyEntry();
    this.failureText.hidden = true;
    this.popup.hidden = true;
    agentTextEditor.editor.editor.focus();
  },
  _resetHotkeyEntry() {
    this.hotkeyEntry.value = "";
    this.hotkeyEntry.hidden = false;
  },
};
