/* eslint-disable no-unused-vars */

const constants = {
  commandTypes: {
    qualityRating: "Translation Quality Rating",
  },
  senders: {
    AGENT: "AGENT",
    END_USER: "END_USER",
    SUBJECT: "SUBJECT",
    SYSTEM: "SYSTEM",
  },
  statuses: {
    ERROR: "ERROR",
    PENDING: "PENDING",
    SUCCESS: "SUCCESS",
    awaiting: "PENDING: Awaiting translation.",
    postFailed: "ERROR: Oracle post event failed.",
    sending: "PENDING: Sending message.",
    sent: "SUCCESS: Message sent.",
  },
  threadTypes: {
    translatedAgent: 2,
    translatedCustomer: 4,
  },
  contactText: "contact your Language I/O representative for assistance.",
  messageTimestampVariation: 5, // in seconds
};

/**
 * toggles whether an HTML element has the given class
 * @param {string} htmlElement element ID
 * @param {string} htmlClass class name to toggle
 */
function toggleElementClass(htmlElement, htmlClass) {
  if (htmlElement.classList.contains(htmlClass)) {
    htmlElement.classList.remove(htmlClass);
    return false;
  } else {
    htmlElement.classList.add(htmlClass);
    return true;
  }
}

/**
 * Returns an array of numbers filling the range
 * @param {number} from the starting number (included)
 * @param {number} to the ending number (included)
 * @param {number} [step] the increment amount (default=1)
 * @returns {number[]}
 */
function range(from, to, step = 1) {
  return Array.from(Array(Math.floor((to - from) / step) + 1)).map((_, i) => from + i * step);
}

function delay(callback, ms) {
  new Promise((r) => {
    setTimeout(r, ms);
  }).then(callback);
}
